package com.steerinfo.meterwork.meterworkmeterlink.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkmeterlink.model.MeterWorkMeterLink;
import com.steerinfo.meterwork.meterworkmeterlink.service.IMeterWorkMeterLinkService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkMeterLink RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-10-19 02:34
 * 类描述
 * 修订历史：
 * 日期：2020-10-19
 * 作者：generator
 * 参考：
 * 描述：MeterWorkMeterLink RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterworkmeterlinks")
@Api(value = "/${api.version}/meterworkmeterlinks", tags = "计量环节配置 - MeterWorkMeterLinkController")
public class MeterWorkMeterLinkController extends BaseRESTfulController {

    @Autowired
    IMeterWorkMeterLinkService meterWorkMeterLinkService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkmeterlink:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkMeterLink> list = meterWorkMeterLinkService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkmeterlink:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkMeterLink> list = meterWorkMeterLinkService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkMeterLink对象创建")
    @ApiImplicitParam(name = "meterWorkMeterLink", value = "详细实体meterWorkMeterLink", required = true, dataType = "MeterWorkMeterLink")
    //@RequiresPermissions("meterworkmeterlink:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkMeterLink model) {
        try {
            MeterWorkMeterLink meterWorkMeterLink = meterWorkMeterLinkService.add(model);
            return success(meterWorkMeterLink);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkmeterlink:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterWorkMeterLink meterWorkMeterLink = meterWorkMeterLinkService.getById(id);
            return success(meterWorkMeterLink);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterWorkMeterLink信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterWorkMeterLink", value = "详细实体meterWorkMeterLink", required = true, dataType = "MeterWorkMeterLink")
    })
    //@RequiresPermissions("meterworkmeterlink:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkMeterLink model) {
        try {
            model.setId(id);
            MeterWorkMeterLink meterWorkMeterLink = meterWorkMeterLinkService.modify(model);
            return success(meterWorkMeterLink);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkmeterlink:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterWorkMeterLinkService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkMeterProcess对象创建")
    @ApiImplicitParam(name = "meterWorkMeterProcess", value = "详细实体meterWorkMeterProcess", required = true, dataType = "MeterWorkMeterProcess")
    //@RequiresPermissions("meterbaserailwayweight:create")
    @PostMapping(value = "/add")
    public RESTfulResult checkandadd(@RequestBody MeterWorkMeterLink model) {
        RESTfulResult rm = failed();
        try {
            MeterWorkMeterLink mwml = meterWorkMeterLinkService.checkandadd(model);
            if (mwml != null) {
                return success(mwml);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "删除", notes = "根据MeterWorkMeterProcess对象停用")
    @PostMapping(value = "/delete")
    public RESTfulResult deleteRe(@RequestBody List<MeterWorkMeterLink> models) {
        RESTfulResult rm = failed();
        try {
            int num = meterWorkMeterLinkService.deleteRe(models);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }
}
